diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/LeapDate.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/LeapDate.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/LeapDate.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/LeapDate.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 1,3 ****
--- 1,9 ----
+ /*
+ Copyright (c) 1999-2007, United States Government, as represented by
+ the Administrator for The National Aeronautics and Space Administration.
+ All rights reserved.
+ */
+ 
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.output.rdr.PDSDate.MissionCal;
***************
*** 332,337 ****
--- 338,347 ----
  		if (daysSinceEpoch >= 18628L) {
  			leaps += 1L;
  		}
+ 		// Jun 30 2012
+ 		if (daysSinceEpoch >= 19905L) {
+ 			leaps += 1L;
+ 		}
  
  		return leaps;
  	}
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPacketsFactory.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPacketsFactory.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPacketsFactory.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPacketsFactory.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 18,46 ****
  public class RawApplicationPacketsFactory {
  
  	public static RawApplicationPackets make(int rawAppsId, RDRName rdrName, int granuleNumber) throws RtStpsException {
! 		if (rdrName == RDRName.CrIS_Science) {
! 			return new CRISRawApplicationPackets(rawAppsId, granuleNumber, true);
! 		} else if (rdrName == RDRName.ATMS_Science) {
! 			return new ATMSRawApplicationPackets(rawAppsId, granuleNumber, true);
! 		} else if (rdrName == RDRName.VIIRS_Science) {
! 			return new VIIRSRawApplicationPackets_MultiGranule(rawAppsId, granuleNumber, true); 
! 		} else if (rdrName == RDRName.NPP_Ephemeris_and_Attitude) {
  			return new SpacecraftDiaryRawApplicationPackets(rawAppsId, granuleNumber, true);
! 		}
  		
  		return null;
  	}
  
  	public static RawApplicationPackets make(RDRName rdrName, int rootGroup, int counter) throws RtStpsException {
! 		if (rdrName == RDRName.CrIS_Science) {
! 			return new CRISRawApplicationPackets(rootGroup, counter);
! 		} else if (rdrName == RDRName.ATMS_Science) {
! 			return new ATMSRawApplicationPackets(rootGroup, counter);
! 		} else if (rdrName == RDRName.VIIRS_Science) {
! 			return new VIIRSRawApplicationPackets_MultiGranule(rootGroup, counter); 
! 		} else if (rdrName == RDRName.NPP_Ephemeris_and_Attitude) {
! 			return new SpacecraftDiaryRawApplicationPackets(rootGroup, counter);
! 		}
  		
  		return null;
  	}
--- 18,49 ----
  public class RawApplicationPacketsFactory {
  
  	public static RawApplicationPackets make(int rawAppsId, RDRName rdrName, int granuleNumber) throws RtStpsException {
! //		if (rdrName == RDRName.CrIS_Science) {
! //			return new CRISRawApplicationPackets(rawAppsId, granuleNumber, true);
! //		} else 
! //			if (rdrName == RDRName.ATMS_Science) {
! //			return new ATMSRawApplicationPackets(rawAppsId, granuleNumber, true);
! //		} else if (rdrName == RDRName.VIIRS_Science) {
! //			return new VIIRSRawApplicationPackets_MultiGranule(rawAppsId, granuleNumber, true); 
! /*		} else if (rdrName == RDRName.NPP_Ephemeris_and_Attitude) {
  			return new SpacecraftDiaryRawApplicationPackets(rawAppsId, granuleNumber, true);
! */	
! 		//}
  		
  		return null;
  	}
  
  	public static RawApplicationPackets make(RDRName rdrName, int rootGroup, int counter) throws RtStpsException {
! //		if (rdrName == RDRName.CrIS_Science) {
! //			return new CRISRawApplicationPackets(rootGroup, counter);
! //		} else 
! //			if (rdrName == RDRName.ATMS_Science) {
! //			return new ATMSRawApplicationPackets(rootGroup, counter);
! //		} else if (rdrName == RDRName.VIIRS_Science) {
! //			return new VIIRSRawApplicationPackets_MultiGranule(rootGroup, counter); 
! //		} else if (rdrName == RDRName.NPP_Ephemeris_and_Attitude) {
! //			return new SpacecraftDiaryRawApplicationPackets(rootGroup, counter);
! //		}
  		
  		return null;
  	}
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPackets.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPackets.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPackets.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RawApplicationPackets.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 226,231 ****
--- 226,236 ----
  	    // Create the data space with unlimited dimensions
  		try {
  			dataSpace = H5.H5Screate_simple (1, totalDims, null);
+ 			
+ 			long     offset[] = new long[1];                                                                // SSEC SRM 2/2/2012
+ 			offset[0]=0; 											// SSEC SRM 2/2/2012
+ 			H5.H5Sselect_hyperslab (dataSpace, HDF5Constants.H5S_SELECT_SET, offset, null, totalDims, null); // SSEC SRM 2/2/2012  
+ 
  		} catch (HDF5Exception e) {
  			throw new RtStpsException(e);
  		}  
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 40,64 ****
  		 * @param pktTrackerIndex the packet tracker index
  		 * @param pktsReceived the packets received
  		 */
! 		public RDRAppIdItem(RDRName rdrName, PacketName packetName, int pktTrackerIndex, int pktsReceived) {
  			this.rdrName = rdrName;
  			this.packetName = packetName;
  			this.name = packetName.toString();
! 			System.out.println("APID List Name:"+this.name);
  			this.value = packetName.getAppId();
  			this.pktTrackerIndex = pktTrackerIndex;
  			
  			//FIXSET1
  			// calculating the concept of reserved is not as trivial as this... so x'd out for now
  			int reserved = rdrName.getGranuleSize() * packetName.getTotalGroupCount() ;
! 			System.out.println("Granule Size:"+rdrName.getGranuleSize());
! 			System.out.println("Group count:"+packetName.getTotalGroupCount());
  			//if (rdrName == RDRName.VIIRS_Science) {
  			//	this.pktsReserved = reserved * 2;  // times 2 is a HACK
  			//} else {
  			this.pktsReserved = reserved;
  			//}
  			
  			//this.pktsReserved = pktsReceived;
  			this.pktsReceived = pktsReceived;
  			
--- 40,74 ----
  		 * @param pktTrackerIndex the packet tracker index
  		 * @param pktsReceived the packets received
  		 */
! 		public RDRAppIdItem(RDRName rdrName, PacketName packetName, int pktTrackerIndex, int pktsReceived, int nextIndex) {
  			this.rdrName = rdrName;
  			this.packetName = packetName;
  			this.name = packetName.toString();
! 			//System.out.println("APID List Name:"+this.name);
  			this.value = packetName.getAppId();
  			this.pktTrackerIndex = pktTrackerIndex;
  			
  			//FIXSET1
  			// calculating the concept of reserved is not as trivial as this... so x'd out for now
  			int reserved = rdrName.getGranuleSize() * packetName.getTotalGroupCount() ;
! 			
! 			
! 		//	System.out.println(");
  			//if (rdrName == RDRName.VIIRS_Science) {
  			//	this.pktsReserved = reserved * 2;  // times 2 is a HACK
  			//} else {
  			this.pktsReserved = reserved;
  			//}
  			
+ 		//	System.out.printf("Packets index %d rec %d next %d \n", pktTrackerIndex,  pktsReceived,  nextIndex);
+ //			this.pktsReserved = pktsReceived;  // srm
+ 
+ 			if ( reserved == 0 ){
+ 			//	System.out.println("Set reserved");
+ 				this.pktsReserved = pktsReceived;
+ 			}
+ 			//System.out.println("RDRAppIdItem Granule Size:"+rdrName.getGranuleSize()+" Group count:"+packetName.getTotalGroupCount()+" reserved "+this.pktsReserved);
+ 
  			//this.pktsReserved = pktsReceived;
  			this.pktsReceived = pktsReceived;
  			
***************
*** 67,76 ****
  			//	this.pktsReserved = 1;
  			//}
  			
! 			System.out.println("Packet [" + name + "] expected [" + 
! 								rdrName.getGranuleSize() * packetName.getTotalGroupCount() + 
! 								"] -- Received [" + 
! 								pktsReceived + "]");
  		}
  	
  		/**
--- 77,86 ----
  			//	this.pktsReserved = 1;
  			//}
  			
! //			System.out.println("Packet [" + name + "] expected [" + 
! //								rdrName.getGranuleSize() * packetName.getTotalGroupCount() + 
! //								"] -- Received [" + 
! //								pktsReceived + "]");
  		}
  	
  		/**
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 52,64 ****
  			this.appIdCount[p.getApplicationId()] += 1;
  		}
  		
! 		// build the AppIdItem list
  		Iterator<PacketName> pni = packetNames.iterator();
  		
  		while (pni.hasNext()) {
  			PacketName packetName = pni.next();
  			int appId = packetName.getAppId();
! 			RDRAppIdItem rdrItem = new RDRAppIdItem(rdrName, packetName, packetTrackerIndex(appId, packetTracker), this.appIdCount[appId]);
  			
  			rdrAppIdList.add(rdrItem);
  		}
--- 52,79 ----
  			this.appIdCount[p.getApplicationId()] += 1;
  		}
  		
! 		int[] trackerIndex = new int[packetNames.size()+1];
! 		// build quick look ahead array
  		Iterator<PacketName> pni = packetNames.iterator();
+ 		int trackIn=0;
+ 		while (pni.hasNext()) {
+ 			PacketName packetName = pni.next();
+ 			int appId = packetName.getAppId();
+ 			trackerIndex[trackIn]= packetTrackerIndex(appId, packetTracker);
+ 			trackIn++;
+ 		}
  		
+ 		// build the AppIdItem list
+ //		Iterator<PacketName>
+ 		pni = packetNames.iterator();
+ 		int index=1;
  		while (pni.hasNext()) {
  			PacketName packetName = pni.next();
+ 			
+ 			
  			int appId = packetName.getAppId();
! 			RDRAppIdItem rdrItem = new RDRAppIdItem(rdrName, packetName, packetTrackerIndex(appId, packetTracker), this.appIdCount[appId],trackerIndex[index]);
! 			index++;
  			
  			rdrAppIdList.add(rdrItem);
  		}
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRBuilderNPP.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRBuilderNPP.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRBuilderNPP.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRBuilderNPP.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 2,34 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
  final public class RDRBuilderNPP {
- 	
- 	private RDRFileWriter rdrBuilderNPP;
- 	
- 	public RDRBuilderNPP(String outputDirectoryPath, Stats stats) throws RtStpsException {
- 		RDR.DocumentName = "D34862-01_E_CDFCB-X_Volume_I_ECR_956B_PR.pdf";
- 		
- 		rdrBuilderNPP = new RDRFileWriter(stats, outputDirectoryPath, 1, 1, Origin.nfts, MissionName.NPP, Origin.nfts, PlatformShortName.NPP);
  
  		
- 	}
  	
  	public void put(Packet p) throws RtStpsException {
! 		rdrBuilderNPP.put(p);
  	}
! 	
  	public void close(boolean hdfCleanup) throws RtStpsException {
! 		rdrBuilderNPP.close(hdfCleanup);
  	}
! 	
  	public String toString() {
! 		return rdrBuilderNPP.toString();
  	}
  }
--- 2,105 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
+ import java.util.ArrayList;
+ 
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
  final public class RDRBuilderNPP {
  
+ 	private RDRFileWriter[] rdrFileWriter = new RDRFileWriter[2];
+ 	private String outputDirectoryPath = null;
+ 	private Stats stats = null;
+ 	private int getAllPacketsIndex = 0;
+ 	private int getDiaryPacketIndex = 1;
+ 
+ 	private boolean only_one_file = true;
+ 
+ 	public RDRBuilderNPP(String outputDirectoryPath, Stats stats)
+ 			throws RtStpsException {
+ 		System.out.println();
+ 		String multiFile = "RTSTPS_MULTI_FILE";
+ 		String value = System.getenv(multiFile);
+ 		if (( value != null) && ( value.length() >= 1))
+ 		{
+ 			if ( !value.contentEquals("\"\""))
+ 			{
+ 				only_one_file = false;
+ 			}
+ 		}
+ 
+ 		if ( only_one_file) {
+ 			System.out.println("RDRBuilderNPP One RDR file per sensor type.");
+ 		}
+ 		else
+ 		{
+ 			System.out.println("RDRBuilderNPP One RDR file or each sensor granule.");
+ 		}
  		
  	
+ 
+ 		RDR.DocumentName = "D34862-01_E_CDFCB-X_Volume_I_ECR_956B_PR.pdf";
+ 		this.outputDirectoryPath = outputDirectoryPath;
+ 		this.stats = stats;
+ 	}
+ 
  	public void put(Packet p) throws RtStpsException {
! 		// keep two file for ach rdr open.
! 		// the first one gets all packets
! 		// the second one only gets spacecraft diary
! 
! 		// System.out.println("Put");
! 		RDRName rdrName = RDRName.fromAppId(p.getApplicationId());
! 		if (rdrFileWriter[getAllPacketsIndex] == null) {
! 			// Write the file only receiving rdrs
! 			// Transition current granule to diary only
! 			System.out.println("RDRBuilderNPP: " + rdrName);
! 
! 			rdrFileWriter[getAllPacketsIndex] = new RDRFileWriter(stats,
! 					outputDirectoryPath, 1, 1, Origin.nfts, MissionName.NPP,
! 					Origin.nfts, PlatformShortName.NPP);
! 
! 		}
! 		if (!only_one_file
! 				&& (rdrFileWriter[getAllPacketsIndex].changeGranule(p))) {
! 
! 			System.out.println("RDRBuilderNPP new file: " + rdrName);
! 			if (rdrFileWriter[getDiaryPacketIndex] != null) {
! 				rdrFileWriter[getDiaryPacketIndex].close(false);
! 			}
! 
! 			// save old one to add diaries
! 			rdrFileWriter[getDiaryPacketIndex] = rdrFileWriter[getAllPacketsIndex];
! 
! 			rdrFileWriter[getAllPacketsIndex] = new RDRFileWriter(stats,
! 					outputDirectoryPath, 1, 1, Origin.nfts, MissionName.NPP,
! 					Origin.nfts, PlatformShortName.NPP);
! 		}
! 		boolean diariesOnly = false;
! 		rdrFileWriter[getAllPacketsIndex].put(p, diariesOnly);
! 
! 		if (rdrFileWriter[getDiaryPacketIndex] != null) {
! 			diariesOnly = true;
! 			rdrFileWriter[getDiaryPacketIndex].put(p, diariesOnly);
! 		}
! 
  	}
! 
  	public void close(boolean hdfCleanup) throws RtStpsException {
! 		if (rdrFileWriter[getDiaryPacketIndex] != null) {
! 			rdrFileWriter[getDiaryPacketIndex].close(false);
! 		}
! 		if (rdrFileWriter[getAllPacketsIndex] != null) {
! 			rdrFileWriter[getAllPacketsIndex].close(hdfCleanup);
! 		}
  	}
! 
  	public String toString() {
! 		return rdrFileWriter.toString();
  	}
  }
